import pandas as pd
from datetime import datetime
import numpy as np
from openpyxl import load_workbook
from db import *



def checkValueIn(dfData,  columnList, valueList):

    error = False
    # isBlank = False
    count = 0

    if dfData is None:
        
        return False, error, None, []

    else:
        try:
            df = pd.DataFrame(dfData)
            # df = df.replace([np.nan],[None])

            # dfColList = list(df.columns)

            # if this is the first validation 
            if 'notValidatedData' not in df.columns.tolist():

                df['notValidatedData'] = ''
                df['notValidatedCol'] = ''

            for index, row in df.iterrows():
                # print("row>>>",row)

                # checking for all the columns given for validation
                for eachCol in columnList:
                    # print("eachCol-columnName", eachCol['columnName'])
                    # print("rowData", row['columnA'])

                    #checking if blank
                    if row[eachCol['columnName']] not in valueList :

                        # isBlank = True
                        count += 1

                        if df.loc[index,'notValidatedData'] != '':
                            df.loc[index, 'notValidatedData'] += ","
                            df.loc[index,'notValidatedCol'] +=  ","


                        # validation message is added and the cell is noted for further process like highlighting, reference etc.

                        # row['notValidatedData'] += str(eachCol['displayName']) + " is blank,"
                        # row['notValidatedCol'] +=  str(eachCol['displayName']) + ","
                        df.loc[index, 'notValidatedData'] += str(eachCol['displayName']) + " is not in " + str(valueList)
                        df.loc[index,'notValidatedCol'] +=  str(eachCol['displayName']) 

                        #adding blank count for the column
                        try:
                            eachCol['count'] += 1
                        except:
                            eachCol['count'] = 1
                

            

        except Exception as e:
            print(e)
            error = True
        
        finally:
            # print("df.loc[1,'notValidatedData']>>>",df)
            return df, count



def checkNull(dfData=None, columnList = [], singleValue=None,):

    error = False
    # isBlank = False
    count = 0

    if dfData is None:
        if singleValue is None or len(singleValue) == 0:
            return True, error, None, []
        else:
            return False, error, None, []

    else:
        try:
            df = pd.DataFrame(dfData)
            df = df.replace([np.nan],[None])

            # if this is the first validation 
            if 'notValidatedData' not in df.columns.tolist():

                df['notValidatedData'] = ''
                df['notValidatedCol'] = ''

            # iterating rows
            for index, row in df.iterrows():
                # print("row>>>",row)

                # checking for all the columns given for validation
                for eachCol in columnList:
                    # print("eachCol-columnName", eachCol['columnName'])
                    # print("rowData", row['columnA'])

                    #checking if blank
                    if row[eachCol['columnName']] in (None, np.nan) or str(row[eachCol['columnName']]).strip() == '':

                        # isBlank = True
                        count += 1

                        if df.loc[index,'notValidatedData'] != '':
                            df.loc[index, 'notValidatedData'] += ","
                            df.loc[index,'notValidatedCol'] +=  ","


                        # validation message is added and the cell is noted for further process like highlighting, reference etc.

                        # row['notValidatedData'] += str(eachCol['displayName']) + " is blank,"
                        # row['notValidatedCol'] +=  str(eachCol['displayName']) + ","
                        print("before add null",df.loc[index,'notValidatedData'])
                        df.loc[index, 'notValidatedData'] += str(eachCol['displayName']) + " is blank"
                        df.loc[index,'notValidatedCol'] +=  str(eachCol['displayName']) 
                        print("After add null",df.loc[index,'notValidatedData'])
                        #adding blank count for the column
                        try:
                            eachCol['count'] += 1
                        except:
                            eachCol['count'] = 1
                
                # if row['notValidatedData'] != '':
                #     row['notValidatedData'] = row['notValidatedData'][:-1]
                #     row['notValidatedCol'] = row['notValidatedCol'][:-1]
                # if df.loc[index,'notValidatedData'] != '':
                #     df.loc[index,'notValidatedData'] = df.loc[index,'notValidatedData'][:-1]
                #     df.loc[index,'notValidatedCol'] = df.loc[index,'notValidatedCol'][:-1]
        


        except Exception as e:
            print(e)
            error = True
        
        finally:
            return df, count
        
def replaceValueInCol(dfData,  columnList, valueList):

    error = False
    # isBlank = False
    count = 0

    if dfData is None:
        
        return False, error, None, []

    else:
        try:
            df = pd.DataFrame(dfData)
            # df = df.replace([np.nan],[None])

            # dfColList = list(df.columns)

            # if this is the first validation 
            if 'notValidatedData' not in df.columns.tolist():

                df['notValidatedData'] = ''
                df['notValidatedCol'] = ''

            # for index, row in df.iterrows():
                # print("row>>>",row)

                # checking for all the columns given for validation
                for eachCol in columnList:
                    # print("eachCol-columnName", eachCol['columnName'])
                    # print("rowData", row['columnA'])

                    #checking if blank
                    try:
                        df[eachCol['columnName']] = df[eachCol['columnName']].replace(valueList[0],valueList[1])
                    except:
                        pass
                

            

        except Exception as e:
            print(e)
            error = True
        
        finally:
            # print("df.loc[1,'notValidatedData']>>>",df)
            return df, count




def checkValueNotIn(dfData,  columnList, valueList):

    error = False
    # isBlank = False
    count = 0

    if dfData is None:
        
        return False, error, None, []

    else:
        try:
            df = pd.DataFrame(dfData)
            # df = df.replace([np.nan],[None])

            # dfColList = list(df.columns)

            # if this is the first validation 
            if 'notValidatedData' not in df.columns.tolist():

                df['notValidatedData'] = ''
                df['notValidatedCol'] = ''

            for index, row in df.iterrows():
                # print("row>>>",row)

                # checking for all the columns given for validation
                for eachCol in columnList:
                    # print("eachCol-columnName", eachCol['columnName'])
                    # print("rowData", row['columnA'])

                    #checking if blank
                    if row[eachCol['columnName']] in valueList :

                        # isBlank = True
                        count += 1

                        if df.loc[index,'notValidatedData'] != '':
                            df.loc[index, 'notValidatedData'] += ","
                            df.loc[index,'notValidatedCol'] +=  ","


                        # validation message is added and the cell is noted for further process like highlighting, reference etc.

                        # row['notValidatedData'] += str(eachCol['displayName']) + " is blank,"
                        # row['notValidatedCol'] +=  str(eachCol['displayName']) + ","
                        df.loc[index, 'notValidatedData'] += str(eachCol['displayName']) + " is in " + str(valueList)
                        df.loc[index,'notValidatedCol'] +=  str(eachCol['displayName']) 

                        #adding blank count for the column
                        try:
                            eachCol['count'] += 1
                        except:
                            eachCol['count'] = 1
                

            

        except Exception as e:
            print(e)
            error = True
        
        finally:
            # print("df.loc[1,'notValidatedData']>>>",df)
            return df, count


def checkExisting(dfData,  columnList):

    error = False
    # isBlank = False
    count = 0

    if dfData is None:
        
        return False, error, None, []

    else:
        try:
            df = pd.DataFrame(dfData)
            df = df.replace([np.nan],[None])

            dfColList = list(df.columns)

            # if this is the first validation 
            if 'notValidatedData' not in df.columns.tolist():

                df['notValidatedData'] = ''
                df['notValidatedCol'] = ''

            # iterating rows
            # for index, row in df.iterrows():
                # print("row>>>",row)

                # checking for all the columns given for validation
            for eachCol in columnList:
                # print("eachCol-columnName", eachCol['columnName'])
                # print("rowData", row['columnA'])

                #checking if blank
                if eachCol['columnName'] not in dfColList:

                    # isBlank = True
                    print("does not exist")
                    count += 1

                    if df.loc[1,'notValidatedData'] != '':
                        df.loc[1, 'notValidatedData'] += ","
                        df.loc[1,'notValidatedCol'] +=  ","


                    # validation message is added and the cell is noted for further process like highlighting, reference etc.

                    # row['notValidatedData'] += str(eachCol['displayName']) + " is blank,"
                    # row['notValidatedCol'] +=  str(eachCol['displayName']) + ","
                    df.loc[1, 'notValidatedData'] += str(eachCol['displayName']) + " is not present"
                    df.loc[1,'notValidatedCol'] +=  str(eachCol['displayName']) 

                    #adding blank count for the column
                    try:
                        eachCol['count'] += 1
                    except:
                        eachCol['count'] = 1
            
            # if row['notValidatedData'] != '':
            #     row['notValidatedData'] = row['notValidatedData'][:-1]
            #     row['notValidatedCol'] = row['notValidatedCol'][:-1]
            # if df.loc[index,'notValidatedData'] != '':
            #     df.loc[index,'notValidatedData'] = df.loc[index,'notValidatedData'][:-1]
            #     df.loc[index,'notValidatedCol'] = df.loc[index,'notValidatedCol'][:-1]
    


        except Exception as e:
            print(e)
            error = True
        
        finally:
            # print("df.loc[1,'notValidatedData']>>>",df)
            return df, count

def checkDuplicateinFile(df,  columnList):
    print("checkDuplicateinFile---------------------------------")
    df = pd.DataFrame(df)
    isDuplicate = False
    count = 0
    notvalidatedmsg = "combination of "
    notValidatedCol = ""
    
    # print(len(columnList))
    

    try:
        
        colname = []
        for col in columnList:
            # print(col)
            notValidatedCol += ','+col['displayName']
            colname.append(col['columnName'])
        # print(colname)
        if len(columnList) == 1:
            notvalidatedmsg = notValidatedCol + " is duplicate in this File"

        else:
            notvalidatedmsg += notValidatedCol + " is duplicate in this File"
        duplicate = df[df.duplicated(colname)]
        # print("duplicate",duplicate)
        for index, row in duplicate.iterrows():

            isDuplicate = True
            count += 1

            if df.loc[index,'notValidatedData'] != '':
                df.loc[index,'notValidatedData'] += ","
                df.loc[index,'notValidatedCol'] += ","

            df.loc[index,'notValidatedData'] += notvalidatedmsg
            df.loc[index,'notValidatedCol'] +=  notValidatedCol
        # print(df)
        return df, count
    except:

        return df, 1


# def checkDuplicateinFile(df,  columnList):
#     print("checkDuplicateinFile---------------------------------")
#     df = pd.DataFrame(df)
#     isDuplicate = False
#     count = 0
#     notvalidatedmsg = "combination of "
#     notValidatedCol = ""
    
#     # print(len(columnList))
    

#     try:
#         if len(columnList) == 1:
#             notvalidatedmsg = notValidatedCol + " is duplicate"

#         else:
#             notvalidatedmsg += notValidatedCol + " is duplicate"
#         colname = []
#         for col in columnList:
#             # print(col)
#             colname.append(col['columnName'])
#         # print(colname)
#         duplicate = df[df.duplicated(colname)]
#         # print("duplicate",duplicate)
#         for index, row in duplicate.iterrows():

#             isDuplicate = True
#             count += 1

#             if df.loc[index,'notValidatedData'] != '':
#                 df.loc[index,'notValidatedData'] += ","
#                 df.loc[index,'notValidatedCol'] += ","

#             df.loc[index,'notValidatedData'] += notvalidatedmsg
#             df.loc[index,'notValidatedCol'] +=  notValidatedCol
#         # print(df)
#         return df, count
#     except:

#         return df, 1

def checkDuplicate(df,  columnList, tableName):

    df = pd.DataFrame(df)
    isDuplicate = False
    count = 0

    cursor = connect_mysql().cursor()

    dupl_sql = "SELECT "
    select_sql = ""
    where_sql = ""
    notvalidatedmsg = "combination of "
    notValidatedCol = ""

    for col in columnList:
        select_sql += col['tableColumnName'] + " ,"
        where_sql += " AND " + col['tableColumnName'] + " = %s "
        notValidatedCol +=  col['displayName'] + ","

    # for col in mappingColumn:
    #     select_sql += col['value'] + " ,"
    #     where_sql += " AND " + col['value'] + " = %s "
    #     notValidatedCol +=  col['displayName'] + ","

    select_sql = select_sql[:-1]
    notValidatedCol = notValidatedCol[:-1]

    if len(columnList) == 1:
        notvalidatedmsg = notValidatedCol + " is duplicate"

    else:
        notvalidatedmsg += notValidatedCol + " is duplicate"

    

    dupl_sql += select_sql + " FROM " + tableName + " WHERE 1 " + where_sql        
    print("dupl_sql>>>",dupl_sql)

    for index, row in df.iterrows():

        data = []
        for col in columnList:
            data.append(row[col['columnName']])
        
        cursor.execute(dupl_sql, data)

        res = cursor.fetchall()
        print("data>>>",data)
        print("res>>>",res)

        if res is not None and len(res) != 0:

            isDuplicate = True
            count += 1

            if df.loc[index,'notValidatedData'] != '':
                df.loc[index,'notValidatedData'] += ","
                df.loc[index,'notValidatedCol'] += ","
            print("before add",df.loc[index,'notValidatedData'])
            df.loc[index,'notValidatedData'] += notvalidatedmsg
            df.loc[index,'notValidatedCol'] +=  notValidatedCol
            print("after add",df.loc[index,'notValidatedData'])

            try:
                col['count'] += 1
            except:
                col['count'] = 1
    
    return df, count

def checkValid(df,  columnList,tableName ,mappingColumn):

    df = pd.DataFrame(df)
    isValid = False
    count = 0

    cursor = connect_mysql().cursor()

    valid_sql = "SELECT "
    select_sql = ""
    where_sql = ""
    notvalidatedmsg = "combination of "
    notValidatedCol = ""

    # for col in columnList:
    #     select_sql += col['tableColumnName'] + " ,"
    #     where_sql += " AND " + col['tableColumnName'] + " = %s "
    #     notValidatedCol +=  col['displayName'] + ","
    for col in mappingColumn:
        select_sql += col['value'] + " ,"
        where_sql += " AND " + col['value'] + " = %s "
    for col in columnList:
    

        notValidatedCol +=  col['displayName'] + ","

    select_sql = select_sql[:-1]
    notValidatedCol = notValidatedCol[:-1]

    if len(columnList) == 1:
        notvalidatedmsg = notValidatedCol + " is not valid"

    else:
        notvalidatedmsg += notValidatedCol + " is not valid"

    

    valid_sql += select_sql + " FROM " + tableName + " WHERE 1 " + where_sql        
    print("valid_sql>>>",valid_sql)

    for index, row in df.iterrows():

        data = []
        for col in columnList:
            data.append(row[col['columnName']])
        
        cursor.execute(valid_sql, data)

        res = cursor.fetchall()

        # print(data)
        # print(res)

        if res is  None or len(res) == 0:

            count += 1
            # print("count validation check",count)

            if df.loc[index,'notValidatedData'] != '':
                df.loc[index,'notValidatedData'] += ","
                df.loc[index,'notValidatedCol'] += ","

            df.loc[index,'notValidatedData'] += notvalidatedmsg
            df.loc[index,'notValidatedCol'] +=  notValidatedCol

            try:
                col['count'] += 1
            except:
                col['count'] = 1

            # print("count validation check",count)
    
    # print(df)
    
    return  df, count



def checkValidafterSplitting(df,  columnList,tableName ,mappingColumn):

    df = pd.DataFrame(df)
    isValid = False
    count = 0

    cursor = connect_mysql().cursor()

    valid_sql = "SELECT "
    select_sql = ""
    where_sql = ""
    notvalidatedmsg = "combination of "
    notValidatedCol = ""

    # for col in columnList:
    #     select_sql += col['tableColumnName'] + " ,"
    #     where_sql += " AND " + col['tableColumnName'] + " = %s "
    #     notValidatedCol +=  col['displayName'] + ","
    for col in mappingColumn:
        print("col>>>",col)
        select_sql += col['value'] + " ,"
        where_sql += " AND " + col['value'] + " = %s "
    for col in columnList:
        notValidatedCol +=  col['displayName'] + ","

    select_sql = select_sql[:-1]
    notValidatedCol = notValidatedCol[:-1]

    if len(columnList) == 1:
        notvalidatedmsg = notValidatedCol + " is not valid"

    else:
        notvalidatedmsg += notValidatedCol + " is not valid"

    

    valid_sql += select_sql + " FROM " + tableName + " WHERE 1 " + where_sql        
    print("valid_sql>>>",valid_sql)

    for index, row in df.iterrows():

        # data = []
        for col in columnList:
            value = str(row[col['columnName']]).split("/")
            for each in value:
                if each.strip() != '':
                    # data.append(each.strip())
            # data.append(row[str(col['columnName']).split("_")])
                    # print("each.strip()>>>",each.strip())
        
                    cursor.execute(valid_sql, (each.strip(),))

                    res = cursor.fetchall()
                    # print("res>>>>",res)

        # print(data)
        # print(res)

                    if res is  None or len(res) == 0:

                        count += 1
                        # print("count validation check",count)

                        if df.loc[index,'notValidatedData'] != '':
                            df.loc[index,'notValidatedData'] += ","
                            df.loc[index,'notValidatedCol'] += ","

                        df.loc[index,'notValidatedData'] += notvalidatedmsg + "("+each.strip()+")"
                        df.loc[index,'notValidatedCol'] +=  notValidatedCol

                        try:
                            col['count'] += 1
                        except:
                            col['count'] = 1

                        break

            # print("count validation check",count)
    
    # print(df)
    
    return  df, count



def checkLength(df, columnList, columnValLengthMin,columnValLengthMax ):
    print("check length")

    isMismatch = False
    count = 0

    df1 = pd.DataFrame(df)

    # print("df>>>",df1)

    for index, row in df1.iterrows():

        for column in columnList:
            notvalidatedmsg = "Length of " + str(column['displayName']) + " value does not match"


            try:
                # print(row[column['columnName']])
                if len(str(row[column['columnName']])) < columnValLengthMin or  len(str(row[column['columnName']])) > columnValLengthMax:
                    isMismatch = True
                    count += 1

                    if df.loc[index,'notValidatedData'] != '':
                        df.loc[index,'notValidatedData'] += ","
                        df.loc[index,'notValidatedCol'] += ","

                    df.loc[index,'notValidatedData'] += notvalidatedmsg
                    df.loc[index,'notValidatedCol'] +=  column['displayName']

                    # print("row['notValidatedData']",row['notValidatedData'])
            
            except:
                count += 1

                if df.loc[index,'notValidatedData'] != '':
                    df.loc[index,'notValidatedData'] += ","
                    df.loc[index,'notValidatedCol'] += ","

                df.loc[index,'notValidatedData'] += notvalidatedmsg
                df.loc[index,'notValidatedCol'] +=  column['displayName']

            finally:
                # print("row>>>",row)
                pass

    # print(df1)

    return  df1, count

    
def checkValidDate(df, columnList,dateFormatList ):
    # try:
    #     date = datetime.strptime(date,'%b-%y')
    # except:
    #     try:
    #         date = datetime.strptime(date,'%y-%b')
    #     except:
    #         pass
    nonValidatedMsg = "Can not extract Date into given format"
    count = 0

    df = pd.DataFrame(df)

    for index, row in df.iterrows():

        for column in columnList:

            extracted = False
            for eachformat in dateFormatList:
                print((df.loc[index, column['columnName']]))

                try:
                    df.loc[index, column['columnName']] = datetime.strptime(str(df.loc[index, column['columnName']]), eachformat)

                    extracted = True
                    break
                except Exception as e:
                    print("e-------------",e)
                    pass
            if extracted == False:
                count += 1

                if df.loc[index,'notValidatedData'] != '':
                    df.loc[index,'notValidatedData'] += ","
                    df.loc[index,'notValidatedCol'] += ","

                df.loc[index,'notValidatedData'] += nonValidatedMsg
                df.loc[index,'notValidatedCol'] +=  column['displayName']

    return df, count


def extractDate(df,  columnList):
    
    count = 0

    df = pd.DataFrame(df)

    print("columnList>>>",columnList)
    print("start extracting date ,,,",columnList[0]['columnName'])
    print(df[columnList[0]['columnName']])

    try:

        for column in columnList:
            df[column['columnName']+ '_year'] = pd.DatetimeIndex(df[column['columnName']]).year
            df[column['columnName']+ '_month'] = pd.DatetimeIndex(df[column['columnName']]).month
            # df[column['columnName']] = pd.to_datetime(df[column['columnName']])
            # print("df[column['columnName']]>>>",df[column['columnName']])
            # df[column['columnName']+ '_year'] = df[column['columnName']].year
            # df[column['columnName']+ '_month'] = df[column['columnName']].month
            

        return df, 0
        
    
    except Exception as e: 
        print("error in date extraction >>>> ",e)

        return df, 1

        

        
def renameCol(df, columnList):

    df = pd.DataFrame(df)

    try:
        for col in columnList:
            df.rename(columns = {col['columnName']:col['displayName']}, inplace = True)

        return df, 0
    except:

        return df, 1








# df = pd.read_csv('/home/pentation/Downloads/target.csv')
# print(df.dtypes)
# # columnList = [{'columnName': 'columnA', 'displayName': 'A Column'},{'columnName': 'columnB', 'displayName': 'B Column'},]
# # columnList = [{'columnName': 'Employee E-Code', 'displayName': 'Employee E-Code'},{'columnName': 'Employee Name', 'displayName': 'Employee Name'},{'columnName': 'Designation', 'displayName': 'Designation'},]
# columnList = [{'columnName': 'Employee E-Code', 'displayName': 'Employee E-Code'},{'columnName': 'Employee Name', 'displayName': 'Employee Name'},{'columnName': 'Designation', 'displayName': 'Designation'}]


# df_res, count = checkNull( df, [{'columnName': 'Employee E-Code', 'displayName': 'Employee E-Code', 'tableColumnName': 'emp_code'}],)

# print("isBlank>>>",isBlank)
# print("error>>>",error)
# print("df_res>>>",df_res)
# print("columnList_res>>>",columnList_res)


# columnListdate = [{'columnName': 'Month', 'displayName': 'Month'},]
# dateFormatList = ['%b-%y', '%y-%b']
# df_res , count = checkValidDate(df_res, dateFormatList,columnListdate)

# columnList_valid = [{'columnName': 'Employee E-Code', 'displayName': 'Employee E-Code',   'tableColumnName' :'emp_code'},{'columnName': 'Branch Name', 'displayName': 'Branch Name' ,'tableColumnName' :'branch_name' }]

# isValid , df_res, columnList = checkValid(df_res,'target_mst',columnList_valid)




# renameCol(df_res, columnList_res)

# columnList_dupl = [{'columnName': 'columnA', 'displayName': 'A Column', 'tableColumnName':''},{'columnName': 'columnB', 'displayName': 'B Column', 'tableColumnName':''}]
# isDuplicate , df_res, columnList_dupl_res = checkDuplicate(df_res,'testdata',columnList_dupl)

# columnList_dupl = [{'columnName': 'columnA', 'displayName': 'A Column'}]
# isDuplicate , df_res, columnList_dupl_res = checkDuplicate(df_res,'testdata',columnList_dupl)

# print(columnList_dupl_res)
# print(isDuplicate)
# print(df_res)

# _, df_res, count = checkLength(df_res, {'columnName': 'Employee E-Code', 'displayName': 'Employee E-Code'} , 6,6 )

# print("count>>>",count)

# df_res = renameCol(df_res, columnList_res)

# columnList = [{'columnName': 'Month', 'displayName': 'Month'  },]
# df_res = extractDate(df_res, columnList)
# print(df_res)







# df_res.to_excel("/home/pentation/Downloads/test.xlsx", index=False)

