from crypt import methods
from flask import Flask, request, Response
from flask_cors import CORS, cross_origin
import json


from api.createModule import moduleCreation
from api.master import master
from api.user import user
from api.kpiParam import kpiParam

fileUpload = '/uploadBulkFile'
app = Flask(__name__)



cors = CORS(app, resources={ r'/*': {'origins': '*'}}, supports_credentials=True)
app.config['CORS_HEADERS'] = 'Content-Type'

app.register_blueprint(moduleCreation, url_prefix = "/moduleCreation")
app.register_blueprint(master, url_prefix = "/master")
app.register_blueprint(user, url_prefix = "/user")
app.register_blueprint(kpiParam, url_prefix = "/kpiParam")



@app.route('/test', methods=['GET'])
def test():
    return {"success": True}

if __name__ == '__main__':
    app.run(host="0.0.0.0", port=5055, debug=True)
    # app.run( port=5000, debug=True)

