from comon import *
from datetime import datetime
import pandas as pd
import numpy as np
from chunk import *
from highlitedCol import highlightCell
# from db import *
from flask import request, jsonify
from flask_cors import CORS,cross_origin
from flask import Blueprint
import os
import pandas as pd
import pymysql
from sqlalchemy import create_engine
from urllib.parse import quote_plus
from allValidation import *


MYSQL_DATABASE_USER= 'root'
MYSQL_DATABASE_PASSWORD= 'password'
# MYSQL_DATABASE_PASSWORD= 'password'

MYSQL_DATABASE_DB= 'tagic_kpi'
#MYSQL_DATABASE_DB= 'tagickpi'
MYSQL_DATABASE_HOST= 'localhost'
# Database connection config
def connect_mysql():
    return pymysql.connect(
        host=MYSQL_DATABASE_HOST, user = MYSQL_DATABASE_USER, passwd = MYSQL_DATABASE_PASSWORD, database = MYSQL_DATABASE_DB,
        autocommit = True, charset = 'utf8mb4', port= 3306,
        cursorclass = pymysql.cursors.DictCursor)
        
        


engine = create_engine('mysql+pymysql://root:%s@127.0.0.1/tagic_kpi' % quote_plus('password'))


        
def renameCol(df, columnList):

    df = pd.DataFrame(df)

    try:
        for col in columnList:
            df.rename(columns = {col['columnName']:col['displayName']}, inplace = True)

        return df, 0
    except:

        return df, 1





ERROR_PATH = BASE_PATH + '/static/error_details/'
UPLOAD_PATH = BASE_PATH + '/static/uploads/'
SPLITTED_DATA = BASE_PATH + '/static/splittedData/'




def update_schedule(fileType_id,channelId,is_uploaded,is_approved,last_uploaded_by = '', last_uploaded_at=''):
    cursor = connect_mysql().cursor()
    update_sql = "UPDATE schedulerFileLog SET isUpload = "+str(is_uploaded)+", isApproved = "+str(is_approved)    
    if last_uploaded_by != '' and last_uploaded_at != '':
        update_sql += " , uploadBy = "+str(last_uploaded_by)+", uploadOn = '"+str(last_uploaded_at)+"'"
    update_sql += " WHERE fileTypeId = "+str(fileType_id)+" and mainChannelId =  "+str(channelId)
    print("update_sql",update_sql)
    cursor.execute(update_sql)
    cursor.close()


def update_control_panel(fileType_id,taskType,is_uploaded,is_approved, taskStatus,month = 'all',year ='all', last_uploaded_by = '', last_uploaded_at=''):

    cursor = connect_mysql().cursor()

    update_sql= "UPDATE `control_panel` SET `taskStatus` = %s, is_approved = %s, is_uploaded = %s "

    if last_uploaded_by != '' and last_uploaded_at != '':
        update_sql += " , lastDoneBy = '"+str(last_uploaded_by)+"', lastDoneAt = '"+str(last_uploaded_at)+"' "
    data = (taskStatus, is_approved,is_uploaded,fileType_id)
    
        # data = (taskStatus, is_approved,is_uploaded,month,year,fileType_id)

    update_sql += " WHERE fileTypeId = %s and taskType = '"+str(taskType)+"' "
    if month != 'all' :
        update_sql += " and month = "+str(month)+ " and year = " +str(year) + " "



    print(update_sql)

    cursor.execute(update_sql,data)

    cursor.close()   





def update_uploaded_file_details(fileId, status):
    cursor = connect_mysql().cursor()
    print(">>>>>>>>>>>>>>>>>>",fileId, status)
    update_sql = "UPDATE `uploaded_file_details` SET  `status` = %s WHERE `id` = %s"
    cursor.execute(update_sql, (status,fileId))
    cursor.close()

def entry_uploaded_file_details(userId,fileName,moduleId, fileTypeId, channelId,month = 'all',year = 'all'):
    cursor = connect_mysql().cursor()
    print(month)

    batchId_sql = "SELECT batchId FROM active_batch"
    cursor.execute(batchId_sql)
    batchId = cursor.fetchone()['batchId']

    print("userId,fileName,moduleId, fileTypeId, channelId")
    print(userId,fileName,moduleId, fileTypeId, channelId)

    if month == 'all':

        entry_sql = "INSERT INTO `uploaded_file_details`(`batchId`, `user_id`, `file_name`, `fileTypeId`,`moduleId`, `channelId`) VALUES (%s, %s, %s, %s, %s, %s)"
        cursor.execute(entry_sql,(batchId,userId,fileName, fileTypeId, moduleId, channelId))
    else:
        entry_sql = "INSERT INTO `uploaded_file_details`(`batchId`, `user_id`, `file_name`, `fileTypeId`,`moduleId`, `channelId`,kpiMonth,kpiYear) VALUES (%s, %s, %s, %s, %s, %s, %s, %s)"
        cursor.execute(entry_sql,(batchId,userId,fileName, fileTypeId, moduleId, channelId,month,year))

    fileId  = cursor.lastrowid
    cursor.close()
    return fileId




def checkTaskSeq(fileType_id,taskType, channelId,month = 'all',year = 'all'):

    cursor = connect_mysql().cursor()

    if taskType == 'score generation':
        if month == 'all':
            searchSqlControler = "SELECT *  FROM `control_panel` WHERE  `seqNo` <(SELECT seqNo FROM control_panel WHERE channelNewId =%s AND taskType = %s AND deleteFlag = 0) AND taskStatus =0 AND deleteFlag = 0 "
        else:
            searchSqlControler = "SELECT *  FROM `control_panel` WHERE  `seqNo` <(SELECT seqNo FROM control_panel WHERE channelNewId =%s AND taskType = %s AND deleteFlag = 0 and month = "+str(month)+" and year = "+str(year)+") AND taskStatus =0 AND deleteFlag = 0 and month = "+str(month)+" and year = "+str(year)+" "


        if channelId != 0:
            searchSqlControler += " AND channelNewId = " + str(channelId)
            
        searchSqlControler += " ORDER BY `control_panel`.`seqNo` ASC"
        print("---------------------- print(searchSqlControler)",searchSqlControler)
        try:
            print(searchSqlControler)
            cursor.execute(searchSqlControler,(channelId,taskType))
            controlerResult = cursor.fetchone()
        except Exception as e:
            print(e)
        print("controlerResult--------------------",controlerResult)
    else:
        if month == 'all':
            searchSqlControler = "SELECT *  FROM `control_panel` WHERE  `seqNo` <(SELECT seqNo FROM control_panel WHERE fileTypeId =%s AND channelNewId = %s AND taskType = %s AND deleteFlag = 0) AND taskStatus =0 AND deleteFlag = 0 "
        else:
            searchSqlControler = "SELECT *  FROM `control_panel` WHERE  `seqNo` <(SELECT seqNo FROM control_panel WHERE fileTypeId =%s AND channelNewId = %s AND taskType = %s AND deleteFlag = 0 and month = "+str(month)+" and year = "+str(year)+" ) AND taskStatus =0 AND deleteFlag = 0 and month = "+str(month)+" and year = "+str(year)+" "

        if channelId != 0:
            searchSqlControler += " AND channelNewId = " + str(channelId)
            
        searchSqlControler += " ORDER BY `control_panel`.`seqNo` ASC"
        print("---------------------- print(searchSqlControler)",searchSqlControler)
        try:
            cursor.execute(searchSqlControler,(fileType_id,channelId,taskType))
            controlerResult = cursor.fetchone()
        except Exception as e:
            print(e)
        print("controlerResult--------------------",controlerResult)

    pending= ""
    if controlerResult is not None:
        # print("controlerResult",controlerResult)
        # for controlPending in controlerResult:
            print("controlPending",controlerResult['taskDetails'])
            pending += str(controlerResult['taskDetails'])+ " "+str(controlerResult['taskType']) + "  pending"
            res = False


    else:
        res = True

        
    print("--------------------------------------------------------------")
    # print("--------------",pending)
    return (res,pending)




def checkTaskSeq(fileType_id,taskType, channelId,month = 'all',year = 'all'):

    cursor = connect_mysql().cursor()

    if taskType == 'score generation':
        if month == 'all':
            searchSqlControler = "SELECT *  FROM `control_panel` WHERE  `seqNo` <(SELECT seqNo FROM control_panel WHERE channelNewId =%s AND taskType = %s AND deleteFlag = 0) AND taskStatus =0 AND deleteFlag = 0 "
        else:
            searchSqlControler = "SELECT *  FROM `control_panel` WHERE  `seqNo` <(SELECT seqNo FROM control_panel WHERE channelNewId =%s AND taskType = %s AND deleteFlag = 0 and month = "+str(month)+" and year = "+str(year)+") AND taskStatus =0 AND deleteFlag = 0 and month = "+str(month)+" and year = "+str(year)+" "


        if channelId != 0:
            searchSqlControler += " AND channelNewId = " + str(channelId)
            
        searchSqlControler += " ORDER BY `control_panel`.`seqNo` ASC"
        print("---------------------- print(searchSqlControler)",searchSqlControler)
        try:
            print(searchSqlControler)
            cursor.execute(searchSqlControler,(channelId,taskType))
            controlerResult = cursor.fetchone()
        except Exception as e:
            print(e)
        print("controlerResult--------------------",controlerResult)
    else:
        if month == 'all':
            searchSqlControler = "SELECT *  FROM `control_panel` WHERE  `seqNo` <(SELECT seqNo FROM control_panel WHERE fileTypeId =%s AND channelNewId = %s AND taskType = %s AND deleteFlag = 0) AND taskStatus =0 AND deleteFlag = 0 "
        else:
            searchSqlControler = "SELECT *  FROM `control_panel` WHERE  `seqNo` <(SELECT seqNo FROM control_panel WHERE fileTypeId =%s AND channelNewId = %s AND taskType = %s AND deleteFlag = 0 and month = "+str(month)+" and year = "+str(year)+" ) AND taskStatus =0 AND deleteFlag = 0 and month = "+str(month)+" and year = "+str(year)+" "

        if channelId != 0:
            searchSqlControler += " AND channelNewId = " + str(channelId)
            
        searchSqlControler += " ORDER BY `control_panel`.`seqNo` ASC"
        print("---------------------- print(searchSqlControler)",searchSqlControler)
        try:
            cursor.execute(searchSqlControler,(fileType_id,channelId,taskType))
            controlerResult = cursor.fetchone()
        except Exception as e:
            print(e)
        print("controlerResult--------------------",controlerResult)

    pending= ""
    if controlerResult is not None:
        # print("controlerResult",controlerResult)
        # for controlPending in controlerResult:
            print("controlPending",controlerResult['taskDetails'])
            pending += str(controlerResult['taskDetails'])+ " "+str(controlerResult['taskType']) + "  pending"
            res = False


    else:
        res = True

        
    print("--------------------------------------------------------------")
    # print("--------------",pending)
    return (res,pending)



def applyFilter(df, filterRules):

    
    
    for filterRule in filterRules:
        print("length of df before filter ", len(df))
        if filterRule['operatorDesc'] == '=':
            try:
                df = df[pd.to_numeric(df[filterRule['columnName']]) == float(filterRule['operationValue'])]
            except:
                df = df[df[filterRule['columnName']] == filterRule['operationValue']]

        elif filterRule['operatorDesc'] == '!=':
            try:
                df = df[pd.to_numeric(df[filterRule['columnName']]) != float(filterRule['operationValue'])]
            except:
                df = df[df[filterRule['columnName']] != filterRule['operationValue']]

        elif filterRule['operatorDesc'] == '>':
            try:
                df = df[pd.to_numeric(df[filterRule['columnName']]) > float(filterRule['operationValue'])]
            except:
                df = df[df[filterRule['columnName']] > filterRule['operationValue']]

        elif filterRule['operatorDesc'] == '<':
            try:
                df = df[pd.to_numeric(df[filterRule['columnName']]) < float(filterRule['operationValue'])]
            except:
                df = df[df[filterRule['columnName']] < filterRule['operationValue']]

        elif filterRule['operatorDesc'] == '<=':
            try:
                df = df[pd.to_numeric(df[filterRule['columnName']]) <= float(filterRule['operationValue'])]
            except:
                df = df[df[filterRule['columnName']] <= filterRule['operationValue']]


        elif filterRule['operatorDesc'] == '>=':
            try:
                df = df[pd.to_numeric(df[filterRule['columnName']]) >= float(filterRule['operationValue'])]
            except:
                df = df[df[filterRule['columnName']] >= filterRule['operationValue']]

        elif filterRule['operatorDesc'] == '<':
            try:
                df = df[pd.to_numeric(df[filterRule['columnName']]) < float(filterRule['operationValue'])]
            except:
                df = df[df[filterRule['columnName']] < filterRule['operationValue']]

        elif filterRule['operatorDesc'] == 'IS NULL':
            
            df = df[df[filterRule['columnName']].isna()]

        elif filterRule['operatorDesc'] == 'NOT NULL':
            
            df = df[~df[filterRule['columnName']].isna()]

        elif filterRule['operatorDesc'] == 'IN':
            try:
                operator_value = eval(filterRule['operationValue'])
             

                try:
                    df = df[pd.to_numeric(df[filterRule['columnName']]).isin(operator_value)]
                except:
                    df = df[df[filterRule['columnName']].isin(operator_value)]

            except:
                pass
        elif filterRule['operatorDesc'] == 'NOT IN':
            try:
                operator_value = eval(filterRule['operationValue'])
             

                try:
                    df = df[~ pd.to_numeric(df[filterRule['columnName']]).isin(operator_value)]
                except:
                    df = df[~ df[filterRule['columnName']].isin(operator_value)]

            except:
                pass


        elif filterRule['operatorDesc'] == 'DATE RANGE':
            try:
                operator_value = eval(filterRule['operationValue'])

                print("operator_value>>>",operator_value)


                dateFormat = eval(filterRule['dateFormat'])

                for frmt in dateFormat:
                    try:
                        df[filterRule['columnName']] = datetime.strptime(str(filterRule['columnName']), frmt)
                        break
                    except:
                        pass
             
                try:
                    df = df[(df[filterRule['columnName']] >= operator_value[0]) & (df[filterRule['columnName']] <= operator_value[1])]
                    # df = df[df[filterRule['columnName']] >= operator_value[0] ]

                    # print(df)


                except Exception as e:
                    print(e)
                    pass

            except Exception as e:
                print(e)
                pass
            
        # print(df)
        print("length of df after filter ", len(df))
        

    print("after applying filter")

    # print(df)



          
    return df

# c




def uploadFileFunc(userId,moduleId,uploadMonth,uploadYear,file):
    conn = connect_mysql()
    cursor = conn.cursor()
    # start = datetime.now()
    # print("starts ", start)
    resp = {"success": False, "message": 'some error occurred', "response": None}
    try:
        
        start = datetime.now()
        print("start------", start)
        # print(request.form)
        # userId = request.form.get('userId')
        # moduleId = request.form.get('moduleId')
        # file = request.files.get('file')
        errorFlag = False
        # try:
        #     uploadYear = request.form.get('uploadYear')
        #     uploadMonth = request.form.get('uploadMonth')
        # except:
        #     uploadYear = 'all'
        #     uploadMonth = 'all'
        # try:
        #     addDataToExisting = request.form.get('addDataToExisting')
        # except:
        #     addDataToExisting = 0
        # if addDataToExisting is None:
        addDataToExisting = 0
        print("userId>>>>>>",userId)
        print("moduleId>>>>>>",moduleId)
        print("file>>>>>>>",file)
        print("upload month -----",uploadMonth)
        fileTypeSql = "SELECT fileTypeId,channelId,tableName FROM `uploadModuleM` WHERE id = %s "
        cursor.execute(fileTypeSql, (moduleId,))
        res= cursor.fetchone()
        print("res>>>",res)
        if res is not None:
            fileTypeId = res['fileTypeId']
            channelId  =res['channelId']

        else:
            return str({'success': False, 'message': 'mention fileType before uploading'})
        
        print("check task sequence",fileTypeId,channelId)
        pending =None
        # resp, pending = checkTaskSeq(fileTypeId, 'upload', channelId)
        # resp, pending = che(resp == True and int(addDataToExisting) == 0) or int(addDataToExisting) ?
        if int(addDataToExisting)  == 0:
            print("entry file")
            fileId = entry_uploaded_file_details(userId,file,moduleId, fileTypeId, channelId,uploadMonth,uploadYear)
            file_name1111= file
            usernameSql = 'SELECT user_name FROM user_details WHERE user_id = %s'
            cursor.execute(usernameSql, (userId,))
            res = cursor.fetchone()
            print("res-------------",res)
            user_name = res['user_name']

            getTableName = "SELECT tableName FROM `uploadModuleM` WHERE id = %s AND active = 1"
            cursor.execute(getTableName, (moduleId,))
            resultTableName = cursor.fetchone()
            if resultTableName is not None:
                tableName = resultTableName['tableName']
            #  SELECT COUNT(*) FROM `avcTargetUpload` WHERE month = 4 AND year = 2024;
 
            alreadyUploadedSql = "  SELECT COUNT(*) FROM " +str(tableName )+ " "
            cursor.execute(alreadyUploadedSql)


            # selective Column in df--------------------------------------------
            validation_sql = " SELECT columnIdList  FROM `uploadModuleConf` WHERE `moduleId` = "+str(moduleId)

            cursor.execute(validation_sql)
            result =cursor.fetchall()
            colList = []
            for each in result :
                # print(each)
                # print(len(each['columnIdList']))
                if len(each['columnIdList']) > 0:

                    for eachCol in eval(each['columnIdList']):
                        # print()
                        # print(eachCol)
                        colList.append(eachCol)


            print(colList)
            # 
            print("len(colList>>>>>>>>>>>>",len(colList))

            if len(colList) == 1:
                colList.append(0)
            # colList = tuple(set(colList))
            colList = tuple(colList)
            column_name_sql = "SELECT columnName FROM `uploadModuleColMapping` where moduleId = "+str(moduleId)+" and (tableColumnName is NOT null "
            
            if len(colList) != 0:
                column_name_sql += " OR id IN "+str(colList)
            column_name_sql += " ) and activeFlag = 1"
            
            print(column_name_sql)
            cursor.execute(column_name_sql)
            res = cursor.fetchall()

            column_name = []

            for col in res:
                if  '_month' in col['columnName'] or '_year' in col['columnName'] :
                    if col["columnName"] in ['abp_month','FinalMonth','Final_Month','Inception_Month','Final_month']:
                        print(col['columnName'])
                        column_name.append(col['columnName'])

                    print(col['columnName'])


                else:
                    column_name.append(col['columnName'])

            print("column_name -----req ----",column_name)
            uploadStartTime = datetime.now()
            print("uploadStartTime>>>>>>>>>>>>>",uploadStartTime)
            
            csv_flag=0

            if file.endswith('.xlsx') == True:
                chunkFileList = ['NA']
                df = pd.ExcelFile(file)

                sheet_names = df.sheet_names
                if int(moduleId) != 258:
                    sheet_names = [sheet_names[0]]
                print(sheet_names)
            
            if file.endswith('.csv') == True:
                csv_flag =1
                print(file)
                filePath =UPLOAD_PATH+file 
                print(file)
                chunkFileList = splitFile(UPLOAD_PATH,file )

                # df = pd.read_csv(file, encoding= 'unicode_escape')
                # df = dd.read_csv(file)
                
                print("111111111111")
                # df = df.compute()

            # else:
            #     df = pd.read_excel(file)

            # print("df['BindDate']>>>>",df['BindDate'])
            # buffer = StringIO()
            # Xlsx2csv(file, outputencoding="utf-8").convert(buffer)
            # buffer.seek(0)
            # df = pd.read_csv(buffer)
           

            dataList=[]
            if csv_flag ==0:
                dataList = sheet_names
            else :
                dataList = chunkFileList


            # for chunkFile in chunkFileList:
            for chunkFile in dataList:
                if csv_flag == 0:
                    df= pd.read_excel(file,sheet_name= chunkFile)
                    
                else:
                    print("chunkFile-------->>>>>>>",chunkFile)
                    df = pd.read_csv(SPLITTED_DATA + chunkFile)
                df = df.dropna(how= 'all')
                uploadEndTime = datetime.now()
                print("uploadEndTime>>>>",uploadEndTime)

                print("total time taken for reading the file>>>>", uploadEndTime - uploadStartTime)

                
                # selected column read
                # print("df.columns selective read>>>>>",df.columns)
                column_name_list =[]
                column_missing = ''
                try: 
                    for eachCol in column_name:
                        if eachCol not in df.columns:
                            column_missing += eachCol + ", "
                            # df[eachCol] = np.nan
                        else :
                            column_name_list.append(eachCol)

                    df = df[column_name_list]
                    print("column_missing -----",column_missing)
                    if column_missing != '':
                        resp = {'success':False, "message":'Column name is missing in excel.Please check the Template.Missing Column are '+column_missing, "error details": column_missing}
                        return resp
                except Exception as e:
                    print ("column name missing",e)

                # getMonthSQL = "SELECT columnName FROM `uploadModuleColMapping` WHERE concat ('[',id,']') like (SELECT columnIdList FROM `uploadModuleConf` WHERE `moduleId` =  %s AND `validationId` = 7 AND activeFlag = 1 ORDER BY seqId limit 1) "
                # print(getMonthSQL)
                # cursor.execute(getMonthSQL, (moduleId,))
                # monthColName = cursor.fetchone()
                # # print("monthColName111111111",monthColName)
                # # print("df.columns $$$$$$$$$$$$>>>>>",df.columns)
                # if monthColName is not None and len(monthColName) != 0 :
                #     monthColName = monthColName['columnName']
                #     # print("monthColName>>>>",monthColName)
                #     print("df>>>>>",df)
                #     # print("df.columns>>>>>",df.columns)
                #     # print("df[monthColName]",df[monthColName])
                #     distMonth = df[monthColName].unique()
                #     print("distMonth>>>>>",distMonth)
                #     # shape check krte hbe
                #     if len(distMonth) == 0:
                #         update_control_panel(fileTypeId,'upload',1,0, 0, uploadMonth,uploadYear,userId, str(datetime.now()))
                #         update_schedule(fileTypeId,channelId,1,0,userId,str(datetime.now()))
                #         update_uploaded_file_details(fileId, 2)
                #         resp = {'success': True, 'response': { "message": ''}} 
                #         return resp
                #     print(type(distMonth[0]))
                #     ts = pd.Timestamp(distMonth[0])
                #     # print("month-----",ts.month)
                #     # print("year-------------",ts.year )
                #     if len(distMonth) >1:
                #         flag = 0 
                #         for eachMonth in distMonth:
                #             print(eachMonth)
                #             if eachMonth is not np.nan:
                #                 ts = pd.Timestamp(eachMonth)
                #                 month = ts.month
                #                 year = ts.year


                #                 if int(uploadMonth) != month or int(uploadYear) != year :
                #                     flag =1
                            

                #         if flag  == 1:
                #             print("multiple month has --------------------------in file")
                #             delete_sql = "DELETE FROM "+str(tableName)+" WHERE fileId  = " +str(fileId) +" "
                #             print("delete_sql",delete_sql)
                #             cursor.execute (delete_sql)
                #             print("deleted")
                #             resp = {'success':False, "message": " Please check the "+str(monthColName)+" column in Uploaded File.In Uploaded file contains Multiple Monrh.Please upload single month data"}
                #             return resp
                #     else:
                #         ts = pd.Timestamp(distMonth[0])
                #         print("month-----",ts.month,int(uploadMonth))
                #         print("year-------------",ts.year,int(uploadYear) )
                #         if int(uploadMonth) != ts.month or int(uploadYear) != ts.year :

                #             resp = {'success':False, "message": " Please check the "+str(monthColName)+" column in Uploaded File. You have selected month "+str(int(uploadMonth))+" and year "+str(int(uploadYear))+", but in Uploaded file contains month "+str( ts.month)+" and year "+str(ts.year)+"."}
                #             return resp
                #         # print("-----------------",type(distMonth[0]))
                #         # if month(distMonth[0])  == uploadMonth:


                # # print("--------------------",distMonth)
                # # print("df", df)
                print(df.columns)
                # df = df.drop(axis=0,labels=0)
                df = df.replace([np.nan], [None])
                df['notValidatedData'] = ''
                df['notValidatedCol'] = ''

                print("length>>>>",len(df))
                


                #get filter rule list

                getFilterRuleSQL = "SELECT * FROM UploadModuleFilterConf umf JOIN uploadModuleColMapping  umc ON umf.moduleId = umc.moduleId AND umf.columnId = umc.id WHERE umf.activeFlag = 1 AND umc.activeFlag = 1 AND umf.moduleId = %s"
                cursor.execute(getFilterRuleSQL, (moduleId,))

                filterData = cursor.fetchall()
                print("filterData>>>",filterData)

                if filterData is not None and  len(filterData) != 0:
                    df = applyFilter(df, filterData)


                

                validaionSql = "SELECT  vm.validationFuncName, vm.validationParamList, uc.* FROM validationM vm JOIN uploadModuleConf uc ON  uc.validationId = vm.id WHERE  uc.moduleId = " + str(moduleId)+"  AND vm.activeFlag = 1 AND uc.activeFlag = 1 ORDER BY uc.seqId ASC"

                

                # print("validaionSql>>>",validaionSql)

                cursor.execute(validaionSql)

                validationList = cursor.fetchall()
                print("validationList>>>>",validationList)
                nonValidatedCount = 0


                if validationList is not None and len(validationList) != 0:

                    for eachValidation in validationList:
                        print("validation start >>>", datetime.now())
                        valStart = datetime.now()
                        print("eachValidation>>>>",eachValidation)

                        if eachValidation['validationParamList'] is not None:

                            vparamList = eval(eachValidation['validationParamList'])

                        else:
                            vparamList = []

                        # print("vparamList>>>",vparamList)
                        if eachValidation['columnId'] is None:

                            columnIdList = eval(eachValidation['columnIdList'])
                            # print("columnIdList>>>",columnIdList)

                            if len(columnIdList) != 0:
                                columnIdList.append(0)
                                columnIdList = tuple(columnIdList)

                                colSql = "SELECT um.columnName, um.displayName, um.tableColumnName FROM uploadModuleColMapping um WHERE um.activeFlag = 1 AND um.moduleId = %s AND um.id IN " + str(columnIdList)
                                # print("colSql>>>",colSql)

                                cursor.execute(colSql, (moduleId,))
                                columnList = cursor.fetchall()
                                # print("columnList>>>", columnList)

                                if columnList is None or len(columnList) == 0:
                                    continue

                                else:
                                    finalParamList = [ columnList]

                                    if vparamList is not None:
                                        for param in vparamList:
                                            # print("param>>>",param)
                                            # print(eachValidation[param])
                                            try:
                                                data = eval(eachValidation[param['paramName']])
                                            except:
                                                data = eachValidation[param['paramName']]
                                                
                                            # print("data>>>",data)

                                            finalParamList.append(data)

                                    # print("finalParamList>>>",finalParamList)

                            else:
                                continue

                        else:
                            finalParamList = [eachValidation['columnName']]

                            if vparamList is not None:
                                for param in vparamList:
                                    try:
                                        data = eval(eachValidation[param['paramName']])
                                    except:
                                        data = eachValidation[param['paramName']]
                                    # finalParamList.append(eval(eachValidation[param]))

                            # print("finalParamList>>>",finalParamList)

                        finalParamList = str(tuple(finalParamList))
                        print("finalParamList>>>",finalParamList)
                        finalParamList = finalParamList[1:]

                        finalParamList = '( df, ' + finalParamList

                        print(eachValidation['validationFuncName'] + str(finalParamList))

                        print("before validation len of df>>>>>>>>", len(df))

                        df, count = eval(eachValidation['validationFuncName'] + str(finalParamList) )
                        print("after validation len of df>>>>>>>>", len(df))

                        nonValidatedCount += count
                        print("nonValidatedCount>>>",nonValidatedCount)
                        print("count",count)
                        print("validation end >>>", datetime.now())
                        print("validation time >>>", datetime.now()- valStart)


                        
                        
                getInsertColSql = "SELECT columnName, tableColumnName, displayName FROM `uploadModuleColMapping` WHERE moduleId = %s AND tableColumnName IS NOT NULL AND  activeFlag = 1"
                cursor.execute(getInsertColSql, (moduleId,))
                insertColList = cursor.fetchall()

                if nonValidatedCount == 0:
                    print("insert data")

                    
                    insertSql = "INSERT INTO " + str(tableName) + '(`fileId`'
                    values = "%s"
                    insertMainData = []

                    for col in insertColList:
                        insertSql += ", `" + str(col['tableColumnName']) + "`"
                        values += ", %s"

                    insertSql += " ) VALUES (" + values + ")"
                    # print("insertSql>>>",insertSql)

                    df = df.replace([np.nan],[None])

                    for index, row in df.iterrows():
                        # print("index>>>",index)
                        # print("row>>>",row)
                        insertData = [fileId,]
                        for col in insertColList:
                            # try:
                            #     insertData.append(row[col['columnName']])
                            #     # print(col,'>>>', row[col['columnName']])
                            # except:
                            #     insertData.append(None)

                            try:
                                if row[col['columnName']] is np.nan or str(row[col['columnName']]) == 'nan':
                                    row[col['columnName']] = None
                                    # print("row[col['columnName']]", row[col['columnName']])

                                insertData.append(row[col['columnName']])
                                # print(col,'>>>', row[col['columnName']])
                            except:
                                insertData.append(None)


                        insertMainData.append(tuple(insertData))

                    # print("insertSql",insertSql)
                    insertMainData = tuple(insertMainData)
                    # print("insertMainData",insertMainData)

                    print("insertMainData length>>>", len(insertMainData))
                    cursor.executemany(insertSql, insertMainData)
                    # 
                    msql = "SELECT moduleDetails  FROM `uploadModuleM` WHERE `id` = %s AND `active` = 1"
                    cursor.execute(msql,(moduleId))
                    moduleDetails = cursor.fetchone()['moduleDetails']
                    # if moduleDetails is not None:
                    #     module = moduleDetails['moduleDetails']

                    # receivers = ['sumanp@pentationanalytics.com','anushrer@pentationanalytics.com']
                    # receivers = ['arpand@pentationanalytics.com']
                    # print("receivers------",receivers)
                    if os.path.isfile(SPLITTED_DATA + chunkFile):
                        if csv_flag == 1:
                            print()
                            os.remove(SPLITTED_DATA + chunkFile)



                
                else:
                    print("return error file")

                    df = pd.DataFrame(df)

                    df, count = renameCol(df,insertColList )

                    print(("df>>>>",df))
                    filename = str(fileId)+"_"+str(tableName)+'_error_data.xlsx'
                    try:
                        # os.remove('/home/APPADMIN/tagic_kpi/API/static/error_details/error_data.xlsx')
                        os.remove(ERROR_PATH + filename)
                        print()
                    except:
                        pass


                    df.to_excel(ERROR_PATH + filename, index=False)
                    highlightCell(ERROR_PATH + filename)
                    
                    # msql = "SELECT moduleDetails  FROM `uploadModuleM` WHERE `id` = %s AND `active` = 1"
                    # cursor.execute(msql,(moduleId))
                    # moduleDetails = cursor.fetchone()['moduleDetails']
                    # 
                    # print("receivers------",receivers)
                    file = ERROR_PATH + filename
                    update_uploaded_file_details(fileId, 3,filename)
                    # 
                    resp = {'success': False, 'response': { "message": str(nonValidatedCount) + " error data found",'error_list':True, "error_count":nonValidatedCount, 'fileName':filename}}

                    errorFlag = True
                    break
            # os.remove(UPLOAD_PATH+file.filename )

            if errorFlag == False:

                # 
                update_control_panel(fileTypeId,'upload',1,0, 0, uploadMonth,uploadYear,userId, str(datetime.now()))
                update_schedule(fileTypeId,channelId,1,0,userId,str(datetime.now()))
                update_uploaded_file_details(fileId, 2)
                resp = {'success': True, 'response': { "message": ''}}
        else:            
            resp = {'success' : False, 'response':{'message' : pending, 'error_list':False}}
        


        
        #     #create insert query
        #     #create insert data

        #     #execute query
        #     #update upload log

        #     resp = {'success':True}

        # else:
        #     #save as error excel
        #     fileName = ''
        #     filePath = ''
        #     highlightCell(filePath)

        #     #update upload log
        #     resp = {'success':False}

        # resp = {'success': True, 'response': { "finalParamList": None}}
    except Exception as e:
        print("e>>> atlast",e)
        update_uploaded_file_details(fileId, 3,filename)
        print("e>>>>>>>>>>>----",e) 
        getTableName = "SELECT tableName FROM `uploadModuleM` WHERE id = %s AND active = 1"
        cursor.execute(getTableName, (moduleId,))
        resultTableName = cursor.fetchone()
        if resultTableName is not None:
            tableName = resultTableName['tableName']
        delete_sql = "DELETE FROM "+str(tableName)+" WHERE fileId  = " +str(fileId) +" "
        print("delete_sql",delete_sql)
        cursor.execute (delete_sql)
        print("deleted")

        resp = {'success':False, "message":'some error occurred. error details: '+ str(e)}

    finally:
        print("end>>>",datetime.now())
        print("total time taken >>> ",datetime.now() - start)
        # print(file.filename)
        try:
            print(file_name1111)
            # print(file.filename)
            os.remove(UPLOAD_PATH+file_name1111 )
        except Exception as e1 :
            print("eeeeeee",e1)
        return resp

folder=  "/home/pentation/Downloads/"
file =  "03 Consumer Distribution - Auto_Apr_16.csv"
# uploadFileFunc(1,257,4,2024,file)
